# Test cases for Lab 13 - Fall 2023
#-------------------------------------------------------------------------------------------
import autotester_base
from autotester_base import Lit, opts

def testall(start=None, mode='brief', clear=True):
   autotester_base.test_target_list(_target_list, _test_cases, start, mode, clear)

def test(fun_or_name, cases=None, mode=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, mode, alias, input, _test_cases)

def vtest(fun_or_name, cases=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, 'verbose', alias, input, _test_cases)

#-------------------------------------------------------------------------------------------

_target_list = [
   'addup', 'smallest', 'countfives', 'reverse', 'double', 'swap', 'commas', 'fib',
   'square', 'subsets', 'anyeven', 'power', 'marshall', 'binary2decimal',
   ]

#-------------------------------------------------------------------------------------------
# verifier functions

def _subsets_verifier(s):
   import itertools
   answer = [b for a in [[''.join(x) for x in itertools.combinations(s, i)]
                         for i in range(len(s)+1)] for b in a]
   answer2 = [''.join(sorted(s)) for s in answer]
   def _verifier(result):
      result2 = [''.join(sorted(s)) for s in result]
      for x in answer:
         if ''.join(sorted(x)) not in result2:
            return "returned %s\nbut should include the subset '%s'" % (result, x)
      for x in result:
         if ''.join(sorted(x)) not in answer2:
            return "returned %s\nbut should not include '%s'" % (result, x)
      if len(set(result2)) != len(result2):
         return "returned %s\nwhich contains duplicate subsets" % (result,)
      return True
   return _verifier

#-------------------------------------------------------------------------------------------

_test_cases = {
   'addup':{
      1: ('', ([],), 0),
      2: ('', ([3],), 3),
      3: ('', ([5, 4, 3, 2, 1],), 15),
      4: ('', ([6, 5, 4, 3, 2, 1],), 21),
      5: ('', ([7, 7, 7, 7, 7, 7, 7, 7, 7, 7],), 70),
      6: ('', ([20, 0, 0, 10],), 30),
      7: ('', ([1, 2],), 3),
      8: ('', ([-1, -2, -3],), -6),
      9: ('', ([0, 0, 0, 0, 0],), 0),
      10: ('', (list(range(101)),), 5050),
   },
   'smallest':{
      1: ('', ([9],), 9),
      2: ('', ([0],), 0),
      3: ('', ([5, 4, 6, 7, 8],), 4),
      4: ('', ([2, 7, 5, 9, 3, 9],), 2),
      5: ('', ([1, 2, 3, 4, 5],), 1),
      6: ('', ([5, 4, 3, 2, 1],), 1),
      7: ('', ([9, 9, 8, 9],), 8),
      8: ('', ([1, -2],), -2),
      9: ('', ([2, 3, 1],), 1),
      10: ('', ([3, 4, 2, 5, 0, 1],), 0),
   },
   'countfives':{
      1: ('', ([],), 0),
      2: ('', ([2],), 0),
      3: ('', ([5],), 1),
      4: ('', ([9, 5],), 1),
      5: ('', ([5, 9],), 1),
      6: ('', ([5, 5],), 2),
      7: ('', ([3, 5, 5],), 2),
      8: ('', ([2, 2, 2, 2],), 0),
      9: ('', ([2, 2, 3, 5, 4],), 1),
      10: ('', ([5, 5, 5, 0, 5, 5, 5],), 6),
   },
   'reverse':{
      1: ('', ('',), ''),
      2: ('', ('x',), 'x'),
      3: ('', ('xy',), 'yx'),
      4: ('', ('abc',), 'cba'),
      5: ('', ('apple',), 'elppa'),
      6: ('', ('banana',), 'ananab'),
      7: ('', ('mississippi',), 'ippississim'),
      8: ('', ('watermelon',), 'nolemretaw'),
      9: ('', ('racecar',), 'racecar'),
      10: ('', ('Racecar',), 'racecaR'),
   },
   'double':{
      1: ('', ('',), ''),
      2: ('', ('x',), 'xx'),
      3: ('', ('apple',), 'aappppllee'),
      4: ('', ('watermelon',), 'wwaatteerrmmeelloonn'),
      5: ('', ('aardvark',), 'aaaarrddvvaarrkk'),
      6: ('', ('Mississippi',), 'MMiissssiissssiippppii'),
      7: ('', ('zoo',), 'zzoooo'),
      8: ('', ('OZ',), 'OOZZ'),
      9: ('', ('123450',), '112233445500'),
      10: ('', ('-1',), '--11'),
   },
   'swap':{
      1: ('', ('o', 'i', ''), ''),
      2: ('', ('o', 'i', 'cat'), 'cat'),
      3: ('', ('o', 'i', 'lollipop'), 'lillopip'),
      4: ('', ('l', 'p', 'lollipop'), 'poppilol'),
      5: ('', ('o', 'x', 'lollipop'), 'lxllipxp'),
      6: ('', ('i', 'z', 'icicle'), 'zczcle'),
      7: ('', ('z', 'i', 'icicle'), 'zczcle'),
      8: ('', ('c', 'i', 'icicle'), 'cicile'),
      9: ('', ('p', 'i', 'mississippi'), 'mpsspsspiip'),
      10: ('', ('x', 'y', 'xyzzy'), 'yxzzx'),
   },
   'commas':{
      1: ('', ('',), ''),
      2: ('', ('1',), '1'),
      3: ('', ('123',), '123'),
      4: ('', ('1234',), '1,234'),
      5: ('', ('1234567',), '1,234,567'),
      6: ('', ('123456789000',), '123,456,789,000'),
      7: ('', ('987654321000123',), '987,654,321,000,123'),
      8: ('', ('98765432100001234',), '98,765,432,100,001,234'),
      9: ('', ('12345',), '12,345'),
      10: ('', ('555555',), '555,555'),
   },
   'fib':{
      1: ('', (1,), 1),
      2: ('', (2,), 1),
      3: ('', (3,), 2),
      4: ('', (4,), 3),
      5: ('', (5,), 5),
      6: ('', (6,), 8),
      7: ('', (7,), 13),
      8: ('', (8,), 21),
      9: ('', (10,), 55),
      10: ('', (20,), 6765),
   },
   'square':{
      1: ('', (1,), 1),
      2: ('', (2,), 4),
      3: ('', (3,), 9),
      4: ('', (4,), 16),
      5: ('', (5,), 25),
      6: ('', (6,), 36),
      7: ('', (13,), 169),
      8: ('', (0,), 0),
      9: ('', (10,), 100),
      10: ('', (25,), 625),
   },
   'subsets':{
      1: ('', ('',), _subsets_verifier('')),
      2: ('', ('a',), _subsets_verifier('a')),
      3: ('', ('ab',), _subsets_verifier('ab')),
      4: ('', ('abc',), _subsets_verifier('abc')),
      5: ('', ('wxyz',), _subsets_verifier('wxyz')),
      6: ('', ('ijklm',), _subsets_verifier('ijklm')),
      7: ('', ('zyx',), _subsets_verifier('zyx')),
      8: ('', ('abcd',), _subsets_verifier('abcd')),
      9: ('', ('x',), _subsets_verifier('x')),
      10: ('', ('pqrstu',), _subsets_verifier('pqrstu')),
   },
   'anyeven':{
      1: ('', ([8],), True),
      2: ('', ([9],), False),
      3: ('', ([3, 5, 6, 7, 9, 10],), True),
      4: ('', ([2, 3, 5, 7, 9],), True),
      5: ('', ([3, 5, 7, 9, 11],), False),
      6: ('', ([],), False),
      7: ('', ([7, 7, 7, 0, 7, 7, 7],), True),
      8: ('', ([7, 7, 7, 7, 0, 7, 7],), True),
      9: ('', ([0],), True),
      10: ('', ([1],), False),
   },
   # 'alleven':{
   #    1: ('', ([8],), True),
   #    2: ('', ([9],), False),
   #    3: ('', ([3, 5, 6, 7, 9, 10],), False),
   #    4: ('', ([3, 4, 6, 8, 10],), False),
   #    5: ('', ([2, 4, 6, 8, 10],), True),
   #    6: ('', ([],), True),
   #    7: ('', ([0, 0, 0],), True),
   #    8: ('', ([0, 1, 0],), False),
   #    9: ('', ([0],), True),
   #    10: ('', ([1],), False),
   # },
   'power':{
      1: ('', (2,4), 16),
      2: ('', (5,0), 1),
      3: ('', (2,1), 2),
      4: ('', (3,2), 9),
      5: ('', (4,3), 64),
      6: ('', (10,5), 100000),
      7: ('', (11,4), 14641),
      8: ('', (10, 0), 1),
      9: ('', (2,8), 256),
      10: ('', (3,6), 729),
   },
   'marshall':{
      1: ('', (1,), 2),
      2: ('', (2,), 2),
      3: ('', (3,), 2),
      4: ('', (4,), 2),
      5: ('', (5,), 2),
      6: ('', (6,), 2),
      7: ('', (7,), 2),
      8: ('', (8,), 2),
      9: ('', (9,), 2),
      10: ('', (10,), 2),
   },
   'binary2decimal':{
      1: ('', ('1',), 1),
      2: ('', ('0',), 0),
      3: ('', ('10',), 2),
      4: ('', ('11',), 3),
      5: ('', ('100',), 4),
      6: ('', ('101',), 5),
      7: ('', ('10101',), 21),
      8: ('', ('101010',), 42),
      9: ('', ('101011',), 43),
      10: ('', ('1111',), 15),
      11: ('', ('1100111000011111010',), 422138),
      12: ('', ('1100111000011111011',), 422139),
   },
}
